# trend_etl

This package contains code and configuration for all ETL processes.

## QuickStart

1. Setup virtual env
   ```
   python3 -m venv .venv        # setup a fresh virtual env for this project
   source .venv/bin/activate    # activate virtual env
   pip install -e ".[develop]"  # install deps for development
   deactivate                   # when done, deactivate virtual env
   ```
2. Run tests
   ```
   python -m unittest discover -p "*_test.py"
   ```

## Deployment
1. We use devpi to deploy to our private index (https://pypi.trend.community).
   ```
   devpi login trend --password='***'
   devpi upload # run this in the root directory of the package
   ```

## Resources
- [python's unittest docs](https://docs.python.org/3/library/unittest.html)
- [devpi docs](https://devpi.net/docs)
