# kafka fields
kafka_value_field = "value"
kafka_timestamp_field = "timestamp"

# fields for bronze tables
bronze_value_field = "value"
bronze_provenance_field = "provenance"
bronze_timestamp_field = "collected_on"
collected_day_field = "collected_day"
created_day_field = "created_day"

# fields for *_idents tables
idents_group_id_field = "group_id"
idents_doc_id_field = "doc_uuid"
idents_source_id_field = "id"

# fields from archives
archive_value_field = "value"  # when read with spark.read.text
archive_job_id_field = "job_id"

reactions_struct_field = "reactions"
source_keys_field = "source_keys"

source_created_at = "created_at"

first_collected_field = "first_collected"
last_collected_field = "last_collected"

# facebook_posts table
facebook_posts_doc_uuid = idents_doc_id_field
facebook_posts_group_id = idents_group_id_field
facebook_posts_created_at = source_created_at
facebook_posts_text = "text"
facebook_posts_permalink_url = "permalink_url"
facebook_posts_reactions = reactions_struct_field
facebook_posts_updated_at = "updated_at"
facebook_posts_type = "type"
facebook_posts_title = "title"
facebook_posts_link = "link"
facebook_posts_story = "story"
facebook_posts_source_keys = source_keys_field

# facebook_comments table
facebook_comments_doc_uuid = idents_doc_id_field
facebook_comments_group_id = idents_group_id_field
facebook_comments_post_uuid = "post_uuid"
facebook_comments_parent_uuid = "parent_uuid"
facebook_comments_created_at = source_created_at
facebook_comments_text = "text"
facebook_comments_permalink_url = "permalink_url"
facebook_comments_reactions = reactions_struct_field
facebook_comments_source_keys = source_keys_field

# facebook_groups table
facebook_groups_uuid = idents_group_id_field
facebook_groups_email = "email"
facebook_groups_description = "description"
facebook_groups_created_at = source_created_at
facebook_groups_name = "name"
facebook_groups_privacy = "privacy"
facebook_groups_member_count = "member_count"
facebook_groups_source_keys = source_keys_field

# subreddits table
subreddits_uuid = idents_group_id_field
subreddits_created_at = source_created_at

# community_groups table
community_groups_source_id = "source_id"
community_groups_source = "source"

# reddit_submissions table
reddit_submissions_created_at = source_created_at
reddit_submissions_text = "text"
reddit_submissions_title = "title"

# reddit_replies table
reddit_replies_created_at = source_created_at
reddit_replies_submission_uuid = "submission_uuid"
reddit_replies_parent_uuid = "parent_uuid"
reddit_replies_text = "text"

# reddit_bot_users table
reddit_bot_users_author = "author"

# docs table
docs_texts = "texts"

# ingestion counts tables
statement_type_field = "statement_type"
count_field = "count"
job_run_id_field = "job_run_id"
batch_id_field = "batch_id"
