facebook_posts_schema = ",".join(
    [
        "id                 string",
        "group_id           string",
        "group_name         string",
        "created_time       string",
        "updated_time       string",
        "link               string",
        "story              string",
        "message            string",
        "anonymized_message string",
        "name               string",
        "anonymized_name    string",
        "permalink_url      string",
        "type               string",
        "reactions_angry    struct<summary struct<total_count long>>",
        "reactions_care     struct<summary struct<total_count long>>",
        "reactions_haha     struct<summary struct<total_count long>>",
        "reactions_like     struct<summary struct<total_count long>>",
        "reactions_love     struct<summary struct<total_count long>>",
        "reactions_none     struct<summary struct<total_count long>>",
        "reactions_pride    struct<summary struct<total_count long>>",
        "reactions_sad      struct<summary struct<total_count long>>",
        "reactions_thankful struct<summary struct<total_count long>>",
        "reactions_wow      struct<summary struct<total_count long>>",
    ]
)

facebook_comments_schema = ",".join(
    [
        "id                 string",
        "group_id           string",
        "group_name         string",
        "created_time       string",
        "message            string",
        "anonymized_message string",
        "parent             struct<id string>",
        "permalink_url      string",
        "post_id            string",
        "reactions_angry    struct<summary struct<total_count long>>",
        "reactions_care     struct<summary struct<total_count long>>",
        "reactions_haha     struct<summary struct<total_count long>>",
        "reactions_like     struct<summary struct<total_count long>>",
        "reactions_love     struct<summary struct<total_count long>>",
        "reactions_none     struct<summary struct<total_count long>>",
        "reactions_pride    struct<summary struct<total_count long>>",
        "reactions_sad      struct<summary struct<total_count long>>",
        "reactions_thankful struct<summary struct<total_count long>>",
        "reactions_wow      struct<summary struct<total_count long>>",
    ]
)

facebook_groups_schema = ",".join(
    [
        "id string",
        "email string",
        "description string",
        "created_time string",
        "name string",
        "privacy string",
        "member_count long",
    ]
)

subreddit_fields = [
    "accept_followers boolean",
    "accounts_active bigint",
    "accounts_active_is_fuzzed boolean",
    "active_user_count bigint",
    "advertiser_category string",
    "all_original_content boolean",
    "allow_chat_post_creation boolean",
    "allow_discovery boolean",
    "allow_galleries boolean",
    "allow_images boolean",
    "allow_polls boolean",
    "allow_prediction_contributors boolean",
    "allow_predictions boolean",
    "allow_predictions_tournament boolean",
    "allow_talks boolean",
    "allow_videogifs boolean",
    "allow_videos boolean",
    "allowed_media_in_comments array<string>",
    "banner_background_color string",
    "banner_background_image string",
    "banner_img string",
    "banner_size array<bigint>",
    "can_assign_link_flair boolean",
    "can_assign_user_flair boolean",
    "collapse_deleted_comments boolean",
    "comment_contribution_settings struct<allowed_media_types array<string>>",
    "comment_score_hide_mins bigint",
    "community_icon string",
    "community_reviewed boolean",
    "created bigint",
    "created_utc bigint",
    "description string",
    "description_html string",
    "disable_contributor_requests boolean",
    "display_name string",
    "display_name_prefixed string",
    "emojis_custom_size array<bigint>",
    "emojis_enabled boolean",
    "free_form_reports boolean",
    "has_menu_widget boolean",
    "header_img string",
    "header_size array<bigint>",
    "header_title string",
    "hide_ads boolean",
    "icon_img string",
    "icon_size array<bigint>",
    "id string",
    "interstitial_warning_message string",
    "is_chat_post_feature_enabled boolean",
    "is_crosspostable_subreddit boolean",
    "is_enrolled_in_new_modmail string",
    "key_color string",
    "lang string",
    "link_flair_enabled boolean",
    "link_flair_position string",
    "mobile_banner_image string",
    "name string",
    "notification_level string",
    "original_content_tag_enabled boolean",
    "over18 boolean",
    "prediction_leaderboard_entry_type string",
    "primary_color string",
    "public_description string",
    "public_description_html string",
    "public_traffic boolean",
    "quarantine boolean",
    "restrict_commenting boolean",
    "restrict_posting boolean",
    "should_archive_posts boolean",
    "should_show_media_in_comments_setting boolean",
    "show_media boolean",
    "show_media_preview boolean",
    "spoilers_enabled boolean",
    "submission_type string",
    "submit_link_label string",
    "submit_text string",
    "submit_text_html string",
    "submit_text_label string",
    "subreddit_type string",
    "subscribers bigint",
    "suggested_comment_sort string",
    "title string",
    "url string",
    "user_can_flair_in_sr boolean",
    "user_flair_background_color string",
    "user_flair_css_class string",
    "user_flair_enabled_in_sr boolean",
    "user_flair_position string",
    "user_flair_richtext array<string>",
    "user_flair_template_id string",
    "user_flair_text string",
    "user_flair_text_color string",
    "user_flair_type string",
    "user_has_favorited boolean",
    "user_is_banned boolean",
    "user_is_contributor boolean",
    "user_is_moderator boolean",
    "user_is_muted boolean",
    "user_is_subscriber boolean",
    "user_sr_flair_enabled boolean",
    "user_sr_theme_enabled boolean",
    "videostream_links_count bigint",
    "whitelist_status string",
    "wiki_enabled boolean",
    "wls bigint",
]
subreddits_schema = f'kind string, data struct<{",".join(subreddit_fields)}>'

submissions_fields = [
    "subreddit_id                  string",
    "name                          string",
    "approved_at_utc               string",
    "selftext                      string",
    "author_fullname               string",
    "saved                         boolean",
    "mod_reason_title              string",
    "gilded                        bigint",
    "clicked                       boolean",
    "title                         string",
    "link_flair_richtext           array<struct<e:string,t:string>>",
    "hidden                        boolean",
    "pwls                          bigint",
    "link_flair_css_class          string",
    "downs                         bigint",
    "thumbnail_height              bigint",
    "top_awarded_type              string",
    "hide_score                    boolean",
    "quarantine                    boolean",
    "link_flair_text_color         string",
    "upvote_ratio                  double",
    "author_flair_background_color string",
    "subreddit_type                string",
    "ups                           bigint",
    "total_awards_received         bigint",
    "thumbnail_width               bigint",
    "author_flair_template_id      string",
    "is_original_content           boolean",
    "user_reports                  array<string>",
    "is_reddit_media_domain        boolean",
    "is_meta                       boolean",
    "category                      string",
    "link_flair_text               string",
    "can_mod_post                  boolean",
    "score                         bigint",
    "approved_by                   string",
    "is_created_from_ads_ui        boolean",
    "author_premium                boolean",
    "thumbnail                     string",
    "edited                        string",
    "author_flair_css_class        string",
    "author_flair_richtext         array<struct<a:string,e:string,t:string,u:string>>",
    "gildings                      struct<gid_1:bigint,gid_2:bigint,gid_3:bigint>",
    "post_hint                     string",
    "content_categories            string",
    "is_self                       boolean",
    "mod_note                      string",
    "link_flair_type               string",
    "wls                           bigint",
    "removed_by_category           string",
    "banned_by                     string",
    "author_flair_type             string",
    "domain                        string",
    "allow_live_comments           boolean",
    "likes                         string",
    "suggested_sort                string",
    "banned_at_utc                 string",
    "view_count                    string",
    "archived                      boolean",
    "no_follow                     boolean",
    "is_crosspostable              boolean",
    "pinned                        boolean",
    "over_18                       boolean",
    "all_awardings                 array<string>",
    "awarders                      array<string>",
    "media_only                    boolean",
    "can_gild                      boolean",
    "spoiler                       boolean",
    "locked                        boolean",
    "author_flair_text             string",
    "treatment_tags                array<string>",
    "visited                       boolean",
    "removed_by                    string",
    "num_reports                   string",
    "distinguished                 string",
    "author_is_blocked             boolean",
    "mod_reason_by                 string",
    "removal_reason                string",
    "link_flair_background_color   string",
    "is_robot_indexable            boolean",
    "report_reasons                string",
    "author                        string",
    "discussion_type               string",
    "num_comments                  bigint",
    "send_replies                  boolean",
    "whitelist_status              string",
    "contest_mode                  boolean",
    "mod_reports                   array<string>",
    "author_patreon_flair          boolean",
    "author_flair_text_color       string",
    "permalink                     string",
    "parent_whitelist_status       string",
    "stickied                      boolean",
    "url                           string",
    "subreddit_subscribers         bigint",
    "num_crossposts                bigint",
    "is_video                      boolean",
]
submissions_schema = (
    f'kind string, data struct<{",".join(submissions_fields + ["created_utc string"])}>'
)
pushshift_submissions_schema = ",".join(
    submissions_fields + ["id string", "created_utc string"]
)

replies_fields = [
    "all_awardings                   array<struct< award_sub_type string,award_type string,awardings_required_to_grant_benefits bigint,coin_price bigint,coin_reward bigint,count bigint,days_of_drip_extension bigint,days_of_premium bigint,description string,end_date string,giver_coin_reward string,icon_format string,icon_height bigint,icon_url string,icon_width bigint,id string,is_enabled boolean,is_new boolean,name string,penny_donate string,penny_price bigint,start_date bigint,static_icon_height bigint,static_icon_url string,static_icon_width bigint,sticky_duration_seconds string,subreddit_coin_reward bigint,subreddit_id string>>",
    "approved_at_utc                 string",
    "approved_by                     string",
    "archived                        boolean",
    "associated_award                string",
    "author                          string",
    "author_cakeday                  boolean",
    "author_flair_background_color   string",
    "author_flair_css_class          string",
    "author_flair_richtext           array<struct<a:string,e:string,t:string,u:string>>",
    "author_flair_template_id        string",
    "author_flair_text               string",
    "author_flair_text_color         string",
    "author_flair_type               string",
    "author_fullname                 string",
    "author_is_blocked               boolean",
    "author_patreon_flair            boolean",
    "author_premium                  boolean",
    "awarders                        array<string>",
    "banned_at_utc                   string",
    "banned_by                       string",
    "body                            string",
    "can_gild                        boolean",
    "can_mod_post                    boolean",
    "collapsed                       boolean",
    "collapsed_because_crowd_control string",
    "collapsed_reason                string",
    "collapsed_reason_code           string",
    "comment_type                    string",
    "controversiality                bigint",
    "distinguished                   string",
    "downs                           bigint",
    "editable                        boolean",
    "edited                          string",
    "gilded                          bigint",
    "gildings                        struct<gid_1:bigint,gid_2:bigint,gid_3:bigint>",
    "is_submitter                    boolean",
    "likes                           string",
    "link_author                     string",
    "link_id                         string",
    "link_permalink                  string",
    "link_title                      string",
    "link_url                        string",
    "locked                          boolean",
    "mod_note                        string",
    "mod_reason_by                   string",
    "mod_reason_title                string",
    "mod_reports                     array<string>",
    "name                            string",
    "no_follow                       boolean",
    "num_comments                    bigint",
    "num_reports                     string",
    "over_18                         boolean",
    "parent_id                       string",
    "permalink                       string",
    "quarantine                      boolean",
    "removal_reason                  string",
    "replies                         string",
    "report_reasons                  string",
    "saved                           boolean",
    "score                           bigint",
    "score_hidden                    boolean",
    "send_replies                    boolean",
    "stickied                        boolean",
    "subreddit_id                    string",
    "subreddit_type                  string",
    "top_awarded_type                string",
    "total_awards_received           bigint",
    "treatment_tags                  array<string>",
    "unrepliable_reason              string",
    "ups                             bigint",
    "user_reports                    array<string>",
]

replies_schema = (
    f'kind string, data struct<{",".join(replies_fields + ["created_utc string"])}>'
)
pushshift_replies_schema = ",".join(
    replies_fields + ["id string", "created_utc string"]
)

discord_user_schema = ",".join(
    [
        "id string",
        "username string",
        "global_name string",
        "avatar string",
        "bot boolean",
        "system boolean",
        "locale string",
        "email string",
        "flags int",
    ]
)

discord_guild_schema = ",".join(
    [
        "id string",
        "name string",
        "icon string",
        "owner boolean",
        "owner_id string",
        "permissions string",
        "features array<string>",
        "verification_level int",
        "approximate_member_count bigint",
        "approximate_presence_count bigint",
        "description string",
    ]
)

discord_channel_schema = ",".join(
    [
        "id string",
        "type int",
        "guild_id string",
        "position int",
        "permission_overwrites array<struct<id string, type int, allow string, deny string>>",
        "name string",
        "topic string",
        "nsfw boolean",
        "owner_id string",
        "rate_limit_per_user int",
        "icon string",
        f"recipients array<struct<{discord_user_schema}>>",
        "parent_id string",
        "message_count bigint",
        "member_count bigint",
        "thread_metadata struct<archived boolean, auto_archive_duration int, archive_timestamp string, locked boolean, invitable boolean, create_timestamp string>",
        f"member struct<id string, user_id string, join_timestamp string, flags int, member struct<user struct<{discord_user_schema}>, nick string, avatar string, joined_at string>>",
        "permissions string",
        "flags int",
        "total_message_sent bigint",
        "available_tags array<struct<id string, name string, moderated boolean, emoji_id string, emoji_name string>>",
        "applied_tags array<string>",
        "default_reaction_emoji struct<emoji_id string, emoji_name string>",
        "default_forum_layout int",
    ]
)

discord_message_schema = ",".join(
    [
        "id string",
        "guild_id string",
        "channel_id string",
        f"author struct<{discord_user_schema}>",
        "content string",
        "timestamp string",
        "edited_timestamp string",
        "tts boolean",
        "mention_everyone boolean",
        f"mentions array<struct<{discord_user_schema}>>",
        "mention_channels array<struct<id string, guild_id string, type int, name string>>",
        "embeds array<struct<title string, type string, description string, url string, timestamp string, image struct<url string>, video struct<url string>, author struct<name string, url string>, provider struct<name string, url string>>>",
        "reactions array<struct<emoji struct<id string, name string>, count bigint, burst_count bigint, count_details struct<burst bigint, normal bigint>, me boolean, burst_me boolean, me_burst boolean>>",
        "pinned boolean",
        "type int",
        "message_reference struct<type int, channel_id string, message_id string, guild_id string>",
        "flags int",
        "thread struct<id string, type int, name string, guild_id string>",
        "sticker_items array<struct<id string, name string, format_type int>>",
        "position int",
        "poll struct<question struct<text string, emoji struct<id string, name string>>, answers array<struct<answer_id int, poll_media struct<text string, emoji struct<id string, name string>>>>, expiry string, allow_multiselect boolean, results struct<is_finalized boolean, answer_counts array<struct<id int, count int, me_voted boolean>>>>",
        "call struct<participants array<string>, ended_timestamp string>",
    ]
)


discord_reaction_schema = ",".join(
    [
        "message_id string",
        "emoji struct<id string, name string>",
        f"user struct<{discord_user_schema}>",
    ]
)

discord_member_schema = ",".join(
    [
        "guild_id string",
        f"user struct<{discord_user_schema}>",
        "nick string",
        "avatar string",
        "roles array<string>",
        "joined_at string",
        "premium_since string",
        "deaf boolean",
        "mute boolean",
        "pending boolean",
        "flags int",
        "permissions string",
        "communication_disabled_until string",
        "avatar_decoration_data struct<asset string, sku_id string>",
    ]
)
