from pyspark.sql import DataFrame
from pyspark.sql.functions import (
    col,
    lit,
)

import trend_etl.schema.fields as fields


# arguments:
#   input_df: the streaming dataframe
# return: a dataframe in the schema expected for a `community_groups` table
def from_bronze_get_community_groups_df(
    input_df: DataFrame, data_source: str
) -> DataFrame:
    return input_df.select(
        col(fields.idents_group_id_field),
        col(fields.idents_source_id_field).alias(fields.community_groups_source_id),
        lit(data_source).alias(fields.community_groups_source),
    )
